diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyInteractive.ml ./src/networks/donkey/donkeyInteractive.ml
--- ./src/networks/donkey/donkeyInteractive.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/donkey/donkeyInteractive.ml	2006-05-25 20:46:10.000000000 +0200
@@ -492,7 +492,7 @@
   match file.file_swarmer with
     None -> ()
   | Some swarmer ->
-      CommonSwarming.verify_all_chunks swarmer false
+      CommonSwarming.verify_all_chunks swarmer
 
   (*
   if file.file_chunks <> [||] then
@@ -598,7 +598,7 @@
   match file.file_swarmer with
     None -> ()
   | Some swarmer ->
-      CommonSwarming.verify_all_chunks swarmer true
+      CommonSwarming.verify_all_chunks_immediately swarmer
 
 let register_commands list =
   register_commands
@@ -1029,13 +1029,13 @@
             P.file_chunks = 
                   (match file.file_swarmer with
                    | None -> "" 
-                   | Some swarmer -> CommonSwarming.verified_bitmap swarmer);
+                   | Some swarmer -> CommonSwarming.chunks_verified_bitmap swarmer);
             P.file_availability =
               [
                 network.network_num,
                 (match file.file_swarmer with
                   | None -> "" 
-                  | Some swarmer -> CommonSwarming.availability swarmer)
+                  | Some swarmer -> CommonSwarming.chunks_availability swarmer)
               ];
             P.file_format = file.file_format;
             P.file_chunks_age = last_seen;
@@ -1293,7 +1293,7 @@
       let chunks =
       (match file.file_swarmer with
        None -> "" | Some swarmer ->
-       CommonSwarming.verified_bitmap swarmer)
+       CommonSwarming.chunks_verified_bitmap swarmer)
       in
 
       html_mods_table_header buf "sourcesTable" "sources al" ([
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyOneFile.ml ./src/networks/donkey/donkeyOneFile.ml
--- ./src/networks/donkey/donkeyOneFile.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/donkey/donkeyOneFile.ml	2006-05-25 20:46:10.000000000 +0200
@@ -162,7 +162,7 @@
       match file.file_swarmer with
         None -> ()
       | Some swarmer ->
-          let bitmap = CommonSwarming.verified_bitmap swarmer in
+          let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
 (*          lprintf "Verified bitmap: [%s]\n" bitmap; *)
           let rec iter i =
             if i =  String.length bitmap then true
@@ -193,7 +193,7 @@
           match file.file_swarmer with
             None -> ()
           | Some swarmer ->
-              let bitmap = CommonSwarming.verified_bitmap swarmer in
+              let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
               let rec iter i len =
                 if i < len then
                   if bitmap.[i] = '3' then
@@ -213,7 +213,7 @@
           (f, chunks, up) :: tail ->
             if f != file then iter tail
             else begin
-                CommonSwarming.update_uploader up
+                CommonSwarming.update_uploader_intervals up
                 (AvailableBitv client_chunks);
                 Bitv.blit client_chunks 0 chunks 0 (Bitv.length chunks)
               end
@@ -235,8 +235,7 @@
   match c.client_download with
     None -> ()
   | Some (file, up) ->
-      CommonSwarming.clear_uploader_block up;
-      CommonSwarming.clear_uploader_ranges up;
+      CommonSwarming.unregister_uploader up;
       c.client_download <- None
 
 let send_get_range_request c file ranges = 
@@ -329,7 +328,7 @@
           let rec iter n =
             if n < 3 then
               try
-                ignore (CommonSwarming.find_range up);
+                ignore (CommonSwarming.find_range up zone_size);
                 iter (n+1)
               with 
                 Not_found -> n
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyShare.ml ./src/networks/donkey/donkeyShare.ml
--- ./src/networks/donkey/donkeyShare.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/donkey/donkeyShare.ml	2006-05-25 20:46:10.000000000 +0200
@@ -111,7 +111,7 @@
 (*    file.file_all_chunks <- String.make file.file_nchunks '1'; *)
     (* Should we trust mtimes, or reverify each file.  If we trust
      * mtimes, I guess we have to call
-     * CommonSwarming.set_verified_bitmap "333..."
+     * CommonSwarming.set_chunks_verified_bitmap "333..."
      * this seems unspeakably ugly, but the alternative is to reverify
      * every shared file every hour.
      *
@@ -126,7 +126,7 @@
     match file.file_swarmer with
       Some s -> (let len = Array.length md4s in
 		 let ver_str = String.make len '3' in
-		     CommonSwarming.set_verified_bitmap s ver_str;
+		     CommonSwarming.set_chunks_verified_bitmap s ver_str;
 		 (*
 		 CommonSwarming.set_present s [(Int64.zero, file_size file)];
 		 (* If we don't verify now, it will never happen! *)
@@ -134,7 +134,7 @@
 		 *)
                 if !verbose_share then
                   lprintf_nl "verified map of %s = %s"
-		         (codedname) (CommonSwarming.verified_bitmap s))
+		         (codedname) (CommonSwarming.chunks_verified_bitmap s))
       | None -> if !verbose_share then lprintf_nl "no swarmer for %s" codedname;
     (try
         file.file_format <- CommonMultimedia.get_info
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/fasttrack/fasttrackGlobals.ml ./src/networks/fasttrack/fasttrackGlobals.ml
--- ./src/networks/fasttrack/fasttrackGlobals.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/fasttrack/fasttrackGlobals.ml	2006-05-25 20:46:10.000000000 +0200
@@ -305,7 +305,7 @@
     }
   in
   incr search_num;
-  let kernel = CommonSwarming.create_swarmer file_temp file_size min_range_size in
+  let kernel = CommonSwarming.create_swarmer file_temp file_size in
   let swarmer = CommonSwarming.create kernel (as_file file)
       file_chunk_size in
   file.file_swarmer <- Some swarmer;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/fileTP/fileTPClients.ml ./src/networks/fileTP/fileTPClients.ml
--- ./src/networks/fileTP/fileTPClients.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/fileTP/fileTPClients.ml	2006-05-25 20:46:10.000000000 +0200
@@ -188,8 +188,8 @@
                               lprintf "Current Block: "; CommonSwarming.print_block b;
                             end;
                           try
-                            let (x,y,r) = CommonSwarming.find_range up in
-
+                            let (x,y,r) = 
+			      CommonSwarming.find_range up min_range_size in
 (*                            lprintf "GOT RANGE:\n"; *)
                             if !verbose_swarming then CommonSwarming.print_uploaders swarmer;
 
@@ -269,7 +269,7 @@
                             let chunks = [ Int64.zero, file_size file ] in
                             let up = CommonSwarming.register_uploader swarmer
                               (as_client c)
-                                (AvailableRanges chunks) in
+                                (AvailableIntervals chunks) in
                             d.download_uploader <- Some up
                       ) c.client_downloads;
 
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/fileTP/fileTPComplexOptions.ml ./src/networks/fileTP/fileTPComplexOptions.ml
--- ./src/networks/fileTP/fileTPComplexOptions.ml	2006-04-09 02:27:04.000000000 +0200
+++ ./src/networks/fileTP/fileTPComplexOptions.ml	2006-05-25 20:46:10.000000000 +0200
@@ -84,7 +84,7 @@
   (match file.file_swarmer with
       None -> ()
     | Some swarmer ->
-        CommonSwarming.value_to_swarmer swarmer assocs;
+        CommonSwarming.value_to_frontend swarmer assocs;
   );
 
   (try
@@ -118,7 +118,7 @@
   match file.file_swarmer with
     None -> assocs
   | Some swarmer ->
-      CommonSwarming.swarmer_to_value swarmer assocs
+      CommonSwarming.frontend_to_value swarmer assocs
 
 let old_files =
   define_option fileTP_section ["old_urls"]
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/fileTP/fileTPGlobals.ml ./src/networks/fileTP/fileTPGlobals.ml
--- ./src/networks/fileTP/fileTPGlobals.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/fileTP/fileTPGlobals.ml	2006-05-25 20:46:10.000000000 +0200
@@ -118,7 +118,7 @@
       in
       file.file_file.impl_file_size <- size;
       let file_temp = Unix32.filename (file_fd file) in
-      let kernel = CommonSwarming.create_swarmer file_temp size min_range_size in
+      let kernel = CommonSwarming.create_swarmer file_temp size in
       let swarmer = CommonSwarming.create kernel (as_file file)
           file_chunk_size in
       file.file_swarmer <- Some swarmer;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/fileTP/fileTPInteractive.ml ./src/networks/fileTP/fileTPInteractive.ml
--- ./src/networks/fileTP/fileTPInteractive.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/fileTP/fileTPInteractive.ml	2006-05-25 20:46:10.000000000 +0200
@@ -81,11 +81,11 @@
         P.file_active_sources = (List.length file.file_clients);
         P.file_chunks = (match file.file_swarmer with
           None -> "" | Some swarmer ->
-            CommonSwarming.verified_bitmap swarmer);
+            CommonSwarming.chunks_verified_bitmap swarmer);
         P.file_availability =
         [network.network_num,(match file.file_swarmer with
           None -> "" | Some swarmer ->
-            CommonSwarming.availability swarmer)];
+            CommonSwarming.chunks_availability swarmer)];
         P.file_format = FormatNotComputed 0;
         P.file_uids = [Uid.create (FileTP file.file_id)];
       }
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/gnutella/gnutellaClients.ml ./src/networks/gnutella/gnutellaClients.ml
--- ./src/networks/gnutella/gnutellaClients.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/gnutella/gnutellaClients.ml	2006-05-25 20:46:10.000000000 +0200
@@ -479,7 +479,7 @@
                   let chunks = [ Int64.zero, file_size file ] in
                   let up = CommonSwarming.register_uploader swarmer 
                       (as_client c)
-                    (AvailableRanges chunks) in
+                    (AvailableIntervals chunks) in
                   d.download_uploader <- Some up;
                   up                
               
@@ -536,7 +536,8 @@
 end;
   *)
                       try
-                        let (x,y,r) = CommonSwarming.find_range up in 
+                        let (x,y,r) = 
+			  CommonSwarming.find_range up (Int64.of_int (256 * 1024)) in 
                         
                         if !verbose_swarming then begin
                             lprintf "GOT RANGE:\n";
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/gnutella/gnutellaComplexOptions.ml ./src/networks/gnutella/gnutellaComplexOptions.ml
--- ./src/networks/gnutella/gnutellaComplexOptions.ml	2006-05-12 23:02:38.000000000 +0200
+++ ./src/networks/gnutella/gnutellaComplexOptions.ml	2006-05-25 20:46:10.000000000 +0200
@@ -141,7 +141,7 @@
   (match file.file_swarmer with
       None -> ()
     | Some swarmer ->
-        CommonSwarming.value_to_swarmer swarmer assocs;
+        CommonSwarming.value_to_frontend swarmer assocs;
         CommonSwarming.set_verifier swarmer (
           match file.file_ttr with
             None -> ForceVerification
@@ -184,7 +184,7 @@
 (*      "file_present_chunks", List
         (List.map (fun (i1,i2) -> 
             SmallList [int64_to_value i1; int64_to_value i2])
-        (CommonSwarming.present_chunks file.file_swarmer));
+        (CommonSwarming.present_intervals file.file_swarmer));
 *)  
     ]
   in
@@ -197,7 +197,7 @@
     match file.file_swarmer with
     None -> assocs 
   | Some swarmer ->
-      CommonSwarming.swarmer_to_value swarmer assocs
+      CommonSwarming.frontend_to_value swarmer assocs
       
 
   (*
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/gnutella/gnutellaGlobals.ml ./src/networks/gnutella/gnutellaGlobals.ml
--- ./src/networks/gnutella/gnutellaGlobals.ml	2006-05-20 01:43:55.000000000 +0200
+++ ./src/networks/gnutella/gnutellaGlobals.ml	2006-05-25 20:46:10.000000000 +0200
@@ -338,8 +338,7 @@
   in
   if !verbose then
     lprintf_nl "SET SIZE : %Ld\n" file_size;
-  let kernel = CommonSwarming.create_swarmer file_temp file_size 
-      (Int64.of_int (256 * 1024))  in
+  let kernel = CommonSwarming.create_swarmer file_temp file_size in
   let swarmer = CommonSwarming.create kernel (as_file file) megabyte in
   CommonSwarming.set_verifier swarmer ForceVerification;
   
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/gnutella/gnutellaInteractive.ml ./src/networks/gnutella/gnutellaInteractive.ml
--- ./src/networks/gnutella/gnutellaInteractive.ml	2006-05-20 01:43:55.000000000 +0200
+++ ./src/networks/gnutella/gnutellaInteractive.ml	2006-05-25 20:46:10.000000000 +0200
@@ -262,7 +262,7 @@
           match file.file_ttr with
             None -> failwith "No TTR for verification"
           | Some ttt ->
-              CommonSwarming.verify_all_chunks swarmer true  
+              CommonSwarming.verify_all_chunks_immediately swarmer
   );  
   
   file_ops.op_file_recover <- (fun file ->
@@ -299,11 +299,11 @@
         
          P.file_chunks = (match file.file_swarmer with
              None -> "" | Some swarmer ->
-               CommonSwarming.verified_bitmap swarmer);
+               CommonSwarming.chunks_verified_bitmap swarmer);
         P.file_availability =   [network.network_num,
            (match file.file_swarmer with
            None -> "" | Some swarmer ->
-                 CommonSwarming.availability swarmer)];
+                 CommonSwarming.chunks_availability swarmer)];
         
         P.file_chunks_age = [|0|];
         P.file_last_seen = BasicSocket.last_time ();
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/utils/lib/unix32.ml ./src/utils/lib/unix32.ml
--- ./src/utils/lib/unix32.ml	2006-05-20 01:43:55.000000000 +0200
+++ ./src/utils/lib/unix32.ml	2006-05-25 20:46:10.000000000 +0200
@@ -1325,16 +1325,64 @@
 let buffered_write_copy t offset s pos_s len_s =
   buffered_write t offset (String.sub s pos_s len_s) 0 len_s
 
+(* like String.compare, but on the first n characters (at most) *)
+let string_comparen s1 s2 n =
+  let len1 = String.length s1 in
+  let len2 = String.length s2 in
+  let rec aux i =
+    if i = n then 0 
+    else 
+      match i = len1, i = len2 with
+      | true, true -> 0
+      | false, true -> 1
+      | true, false -> -1
+      | false, false ->
+	  let cmp = (int_of_char s1.[i]) - (int_of_char s2.[i]) in
+	  if cmp <> 0 then cmp
+	  else aux (i+1) in
+  aux 0
+
 let copy_chunk t1 t2 pos1 pos2 len =
   flush_fd t1;
   flush_fd t2;
   let buffer_size = 128 * 1024 in
   let buffer = String.make buffer_size '\001' in
+  (* to prevent allocating disk space by writting zeroes over
+     otherwise sparse files, we check if writes would change
+     target file content before proceeding; 
+     Since failures are expensive (one additionnal read of target
+     chunk), after 3 failures we assume source and
+     target are different and revert to plain old copying *)
+  let buffer_tgt = String.make buffer_size '\001' in
+  let maybe_sparse = ref true in
+  let found_different_credit = ref 3 in
+
   let rec iter remaining pos1 pos2 =
     let len = mini remaining buffer_size in
     if len > 0 then begin
       read t1 pos1 buffer 0 len;
-      write t2 pos2 buffer 0 len;
+      let is_different = 
+	if not !maybe_sparse then true
+	else
+	  try
+	    read t2 pos2 buffer_tgt 0 len;
+	    let result = string_comparen buffer buffer_tgt len <> 0 in
+	    if result && !verbose then
+	      lprintf_nl "copy_chunk: target is different";
+	    result
+	  with _ -> 
+	    (* reached end of target file, or any other oddity ? 
+	       revert to plain copying immediately *)
+	    maybe_sparse := false;
+	    true  in
+      if is_different then begin
+	if !found_different_credit > 0 then begin
+	  decr found_different_credit;
+	  (* too many differences ? give up cleverness *)
+	  if !found_different_credit = 0 then maybe_sparse := false
+	end;
+        write t2 pos2 buffer 0 len;
+      end;
       let len64 = Int64.of_int len in
       iter (remaining - len) (pos1 ++ len64) (pos2 ++ len64)
     end
